Attribute VB_Name = "ModHigh"
Option Explicit

Private Const ANLeft = 35       'Left line for Up to Down
Private Const ANMid = 240       'Middle Location for Marker
Private Const ANTop = 210       'Top line for Left to Right
Private Const ANBTop = 255      'Top line for Right to Left
Private Const StepInc = 5       'Increment Val for animation

Dim HTimerID As Long            'Timer ID for High Score Display

Dim CurX As Integer             'Copter X
Dim CurY As Integer             'Copter Y

Dim Step As Integer             'Current Animation Sequence

Dim CopterStep As Integer       'Current Animation Sequence for Copter
Dim MarkStep As Integer         'Current Animation Sequence for Marker
Dim ScoreStep As Integer        'Current Animation Sequence for Score

Dim Scores(2) As String         'High Score List

Public BS As Boolean            'Indicates if this is a Best Time Screen
                                'or Completed game screen

'Loads the fHighs display and high scores list
Public Sub CheckWinningTime()

Dim Buffer As String            'Generic String container
Dim Splitbuf() As String        'Split Container
Dim FileNum As Long             'File Number for high scores
Dim i As Integer                'Generic Counter

Load fHighs     'Get the display ready

FileNum = FreeFile  'Get a file number

Open "scores.ms2" For Input As #FileNum     'Open the file
    
Input #FileNum, Buffer      'Get the info

'if there was a file then split and get the scores
If Buffer <> "" Then
    
    Splitbuf = Split(Buffer, "|")
    
    For i = 0 To 2
        
        Scores(i) = Splitbuf(i)
        
    Next
    
End If

'Look through the list, if the ticker time was better than the file time
'then get the initials and set the new info
For i = 0 To 2
    
    Splitbuf = Split(Scores(i), "=")
    
    If Splitbuf(1) > Ticker Then
        
        Buffer = InputBox("Congratulations you have a top time. Enter " _
            & "3 Characters Maximum", "Best Time!!")
        
        If Buffer <> "" Then
            
            Buffer = Mid(Buffer, 1, 3)
            
            Buffer = Buffer & "=" & Ticker
            
        Else
            
            'Default to AAA if fails
            Buffer = "AAA=" & Ticker
            
        End If
        
        Scores(i) = Buffer
        
        Exit For
        
    End If
    
Next

'Close the file
Close FileNum

'Clear the buffer for more use
Buffer = ""

'Put the storage string together and save it
For i = 0 To 2
    
    If i < 2 Then
        
        Buffer = Buffer & Scores(i) & "|"
        
    Else
        
        Buffer = Buffer & Scores(i)
        
    End If
    
Next

Open "scores.ms2" For Output As #FileNum

Print #FileNum, Buffer

Close #FileNum

'Set the animation timer for the high score display
HTimerID = SetTimer(fHighs.hwnd, 1, 125, AddressOf HighCallBack)

'Set the start spots
CurX = fHighs.ScaleWidth + 1

CurY = ANTop

'Display first high score
Splitbuf = Split(Scores(ScoreStep), "=")

fHighs.lInfo.Caption = (ScoreStep + 1) & " : " & Splitbuf(0) & "    " & Splitbuf(1) _
    & " secs."

ScoreStep = ScoreStep + 1

'Show the display
fHighs.Show

End Sub

Public Sub HighCallBack(ByVal hwnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, _
        ByVal dwTime As Long)

Dim Splitbuf() As String

'clear the display
fHighs.Cls

'Get the current animation sequence
Select Case Step
    Case 0
        
        'Right to Left
        If CopterStep = 0 Then
            
            BitBlt fHighs.hDC, CurX, CurY, GridSize, GridSize, fMain.pCM(1).hDC, _
                60, 0, vbSrcAnd
            
            BitBlt fHighs.hDC, CurX, CurY, GridSize, GridSize, fMain.pCM(0).hDC, _
                60, 0, vbSrcPaint
                
            CopterStep = 1
            
        Else
            
            BitBlt fHighs.hDC, CurX, CurY, GridSize, GridSize, fMain.pCM(1).hDC, _
                60, 20, vbSrcAnd
            
            BitBlt fHighs.hDC, CurX, CurY, GridSize, GridSize, fMain.pCM(0).hDC, _
                60, 20, vbSrcPaint
            
            CopterStep = 0
            
        End If
        
        'Set the next frame position
        If CurX >= ANLeft Then
            
            CurX = CurX - StepInc
            
        Else
            
            'If the ani is at the left position go down
            Step = 1
            
        End If
        
    Case 1
        
        'Up to Down
        'If we are half way down draw the marker in it current sequence
        If CurY >= ANMid Then
            
            BitBlt fHighs.hDC, ANLeft, ANMid, 20, 20, fHighs.pPoint.hDC, _
                (GridSize * MarkStep), 0, vbSrcCopy
            
            'Loop the animation for the Marker
            If MarkStep < 4 Then
                
                MarkStep = MarkStep + 1
                
            Else
                
                MarkStep = 0
                
            End If
            
        End If
        
        'Draw the copter at the current X and Y
        If CopterStep = 0 Then
            
            BitBlt fHighs.hDC, CurX, CurY, GridSize, GridSize, fMain.pCM(1).hDC, _
                40, 0, vbSrcAnd
            
            BitBlt fHighs.hDC, CurX, CurY, GridSize, GridSize, fMain.pCM(0).hDC, _
                40, 0, vbSrcPaint
            
            CopterStep = 1
            
        Else
            
            BitBlt fHighs.hDC, CurX, CurY, GridSize, GridSize, fMain.pCM(1).hDC, _
                40, 20, vbSrcAnd
            
            BitBlt fHighs.hDC, CurX, CurY, GridSize, GridSize, fMain.pCM(0).hDC, _
                40, 20, vbSrcPaint
            
            CopterStep = 0
            
        End If
        
        If CurY <= ANBTop Then
            
            CurY = CurY + StepInc
            
        Else
            
            Step = 2
            
        End If
        
    Case 2
    
        'Left to Right
        BitBlt fHighs.hDC, ANLeft, ANMid, 20, 20, fHighs.pPoint.hDC, _
                (GridSize * MarkStep), 0, vbSrcCopy
              
        'Draw the marker
        If MarkStep < 4 Then
                
            MarkStep = MarkStep + 1
                
        Else
                
            MarkStep = 0
                
        End If
        
        'Draw the copter
        If CopterStep = 0 Then
            
            BitBlt fHighs.hDC, CurX, CurY, GridSize, GridSize, fMain.pCM(1).hDC, _
                0, 0, vbSrcAnd
            
            BitBlt fHighs.hDC, CurX, CurY, GridSize, GridSize, fMain.pCM(0).hDC, _
                0, 0, vbSrcPaint
            
            CopterStep = 1
            
        Else
            
            BitBlt fHighs.hDC, CurX, CurY, GridSize, GridSize, fMain.pCM(1).hDC, _
                0, 20, vbSrcAnd
            
            BitBlt fHighs.hDC, CurX, CurY, GridSize, GridSize, fMain.pCM(0).hDC, _
                0, 20, vbSrcPaint
            
            CopterStep = 0
            
        End If
        
        'Reset for the next loop of the animation
        If CurX < fHighs.ScaleWidth Then
            
            CurX = CurX + StepInc
            
        Else
            
            Splitbuf = Split(Scores(ScoreStep), "=")
            
            fHighs.lInfo.Caption = (ScoreStep + 1) & " : " & Splitbuf(0) & "    " & _
                Splitbuf(1) & " secs."
            
            If ScoreStep <> 2 Then
            
                ScoreStep = ScoreStep + 1
            
            Else
            
                ScoreStep = 0
            
            End If
            
            Step = 0
            
            CurX = fHighs.ScaleWidth + 1

            CurY = ANTop
            
        End If
        
End Select

'Display the new screen
fHighs.Refresh

End Sub
